#pragma once
#include "UIElement.h"
#include "FTState.h"
#include "FTStateManager.h"

#define  DRAW_RECTFRAME  // if defined, draw the arrounded frame specific to control


class UIChatFileElement : public UIElement
	, public ITranslateItemCallBack
{
public:
	UIChatFileElement(CChatItem* pChatItem, IUIElementResouce* pResouce);
	virtual ~UIChatFileElement();

	virtual BOOL Draw( Graphics *graph );
	virtual CSize CalcSize( const CPoint& ptPos, DWORD dwFlags);
	CSize _CalcReSendStatus( const CPoint& ptPos, CSize& sz );
	void DrawRetryStatus(Graphics* graph, CRect rcPS);
	
	virtual void OnLButtonDown(UINT nFlags, CPoint point);
	virtual void OnLButtonUp(UINT nFlags, CPoint point);
	virtual BOOL OnMouseMove( UINT nFlags, CPoint point );
	CChatFileItem* GetChatFileItem();
	INT GetProgress() const { return m_nProgress; }	
	//ITranslateItemCallBack
	virtual void OnTransferStart(TranslateFileInfo& fileInfo);
	virtual void OnTransferProgress(TranslateFileInfo& fileInfo, INT nProgress, BOOL bCalcSize);
	virtual void OnTransferError(TranslateFileInfo& fileInfo, TransferError err);
	virtual void OnTransferEnd(TranslateFileInfo& fileInfo, TransferStatus status);
public:
	IUIElementResouce* GetElementResource();
	DWORD GetFlags() { return m_dwFlags; }
	

//	void  DrawProgressBar(  CPoint pt_left_top);
//	void  DrawCancelButton(  CPoint pt_left_top);
//	void  DrawFileIcon(  CPoint pt_left_top);
//	void  DrawFileName(  CPoint pt_left_top);
//	void  DrawErrorCode(  CPoint pt_left_top);

//private:
//	CSize  GetMaxSize(CSize sz_basic, CPoint pt_offset);
	//BOOL   DrawItems(CPoint pt_offset, Graphics *graph );
private:
	FileTransferState::CFTStateManager*  m_pStateManager;
	INT			                         m_nProgress;

};
